"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ora = ora;
exports.logNewSection = logNewSection;

function _chalk() {
  const data = _interopRequireDefault(require("chalk"));

  _chalk = function () {
    return data;
  };

  return data;
}

function _commander() {
  const data = _interopRequireDefault(require("commander"));

  _commander = function () {
    return data;
  };

  return data;
}

function _ora() {
  const data = _interopRequireDefault(require("ora"));

  _ora = function () {
    return data;
  };

  return data;
}

function _log() {
  const data = _interopRequireDefault(require("../log"));

  _log = function () {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A custom ora spinner that sends the stream to stdout in CI, non-TTY, or expo's non-interactive flag instead of stderr (the default).
 *
 * @param options
 * @returns
 */
function ora(options) {
  const inputOptions = typeof options === 'string' ? {
    text: options
  } : options || {};

  const disabled = _commander().default.nonInteractive || _log().default.isDebug;

  const ora = (0, _ora().default)({
    // Ensure our non-interactive mode emulates CI mode.
    isEnabled: !disabled,
    // In non-interactive mode, send the stream to stdout so it prevents looking like an error.
    stream: disabled ? process.stdout : process.stderr,
    ...inputOptions
  }); // Always make the central logging module aware of the current spinner

  _log().default.setSpinner(ora);

  return ora;
}
/**
 * Create a unified section spinner.
 *
 * @param title
 * @returns
 */


function logNewSection(title) {
  const spinner = ora(_chalk().default.bold(title)); // Prevent the spinner from clashing with debug logs

  spinner.start();
  return spinner;
}
//# sourceMappingURL=ora.js.map